function Item(){
	this.previouslyPickedUp = false;
	this.equipped = false;
	//set quality
	//special properties
	
	//set name based on quality
	
	this.description = "";
	
	this.wetness = 0;
	this.waterResistance = 0;
	
	this.name = "??";
	
	this.hallucinate = Math.random()*275+25;
}

Item.prototype.use=function(){
	rconsole.log("Cannot be used.");
}

Item.prototype.getName=function(){
	//add quality+type+special properties
	if(this.hallucinate<player.hallucinate){
		return "???";
	}else{
		return this.name;
	}
}

Item.prototype.getFormattedWeight = function(){
	return this.weight+"lb";
}

Item.prototype.getDescription=function(){
	if(this.hallucinate<player.hallucinate){
		return "???";
	}

	//add quality+type+special properties
	return this.description + this.getExtraDetails()+this.getWeightDetails();
}

Item.prototype.getExtraDetails=function(){
	return "";
}

Item.prototype.getWeightDetails = function(){
	var details = "";

	if(this.weightBonus===1){
		details += '<div class="bonus">';
	}else if(this.weightBonus===-1){
		details += '<div class="penalty">';
	}else{
		details += '<div>';
	}
	details += "Weight: " + Math.floor(this.weight*10)/10+"lb";
	details += '</div>';

	return details;
}

Item.prototype.draw = function(ctx,img, tile, x, y,bufferCanvas,bufferCtx,shadow){
	var height = tile.getHeight();

	bufferCtx.clearRect(0,0,64,64);
	bufferCtx.globalCompositeOperation="source-over";
	bufferCtx.drawImage(img,this.ssX,this.ssY,16,8,0,0,64,32);

	if(shadow>0){
		bufferCtx.globalCompositeOperation="source-atop";
		bufferCtx.fillStyle = "rgba(5,0,15,"+shadow+")";
		bufferCtx.fillRect(0,0,64,64);
	}
					
	ctx.drawImage(bufferCanvas, x*64,(y)*32-height+(player.z)-16);
}

Item.prototype.drawInventory = function(ctx,img,x,y){
	ctx.drawImage(img,this.ssX,this.ssY,16,8,x,y,64,32);
}

Item.prototype.drawEquipped = function(ctx,img,waterOffset){
	if(this.equipped && this.equipX != undefined && this.equipY != undefined){
		ctx.drawImage(img,this.equipX,this.equipY,16,16,map.playerDrawX*64,map.playerDrawY*32-40+waterOffset,64,64);
	}
}






		
function Clothing(){
	Item.call(this);

	this.isClothing = true;
	this.canStack = false;
	this.lastLeg = false;
	this.side = null;
}
Clothing.prototype = new Item();
Clothing.prototype.constructor = Clothing;
		
Clothing.prototype.use = function(){
	//equip (check stack first)
	
	if(this.equipped){
		this.equipped = false;
		if(this.lastLeg){
			this.coldResistance *= .8;
			this.waterResistance *= .8;
			this.windResistance *= .8;
		
		
			this.coldBonus = -1;
			this.waterBonus = -1;
			this.windBonus = -1;
			
			rdetail.setItemDetail(this.getName(),this.getDescription());
		}
	}else{
		var canLayer = true;
		var items = inventory.items;
		for(var i=0;i<items.length;i++){
			if(items[i]!== null && items[i].equipped && !items[i].canStack && items[i].equipType === this.equipType){
				canLayer = false;
				break;
			}
		}
		
		if(canLayer){
			this.equipped = true;
		}else{
			rconsole.log("The clothes you are already wearing prevent further layering.");
		}
	}
}
		
Clothing.prototype.getName = function(){
	if(this.hallucinate<player.hallucinate){
		return "???";
	}

	var name = this.clothingType;
	if(this.side!==null){
		name = this.side + " " + name;
	}
	
	name=inventory.qualities[this.quality]+" "+name;
	
	return name;
}

Clothing.prototype.getExtraDetails = function(){
	var details = "";
	
	if(this.coldBonus===1){
		details += '<div class="bonus">';
	}else if(this.coldBonus===-1){
		details += '<div class="penalty">';
	}else{
		details += '<div>';
	}
	details += "Cold resistance: <strong>" + Math.floor(this.coldResistance*100)+"</strong>%";
	details += '</div>';
	
	
	if(this.windBonus===1){
		details += '<div class="bonus">';
	}else if(this.windBonus===-1){
		details += '<div class="penalty">';
	}else{
		details += '<div>';
	}
	details += "Wind resistance: <strong>" + Math.floor(this.windResistance*100)+"</strong>%";
	details += '</div>';
	
	
	if(this.waterBonus===1){
		details += '<div class="bonus">';
	}else if(this.waterBonus===-1){
		details += '<div class="penalty">';
	}else{
		details += '<div>';
	}
	details += "Water resistance: <strong>" + Math.floor(this.waterResistance*100)+"</strong>%";
	details += '</div>';
	
	
	//todo: stack bonus, last leg, weight bonus
	
	if(this.stackBonus===1){
		details += '<div class="bonus">';
	}else if(this.stackBonus===-1){
		details += '<div class="penalty">';
	}else{
		details += '<div>';
	}
	if(this.canStack){
		details += "SLIM (can layer on top of this item)";
	}else{
		details += "BULKY (can not layer on top of this item)";
	}
	details += '</div>';
	
	if(this.lastLeg){
		details += '<div class="penalty">THREADBARE (gets worse when removed)</div>';
	}
	
	return details;
}

Clothing.prototype.mutate = function(){
	var r = Math.random();
	
	this.stackBonus = 0;
	this.coldBonus = 0;
	this.waterBonus = 0;
	this.windBonus = 0;
	this.weightBonus = 0;
	
	
	var r1,r2;
	
	var positiveChance, negativeChance;
	
	if(r<.6){
		this.quality = 0;
	}else if(r<.9){
		this.quality = 1;
	}else if(r<.95){
		this.quality = 2;
	}else if(r<.99){
		this.quality = 3;
	}else{
		this.quality = 4;
	}
	
	this.quality = Math.min(4,this.qualityBonus+this.quality);
	
	if(this.quality===0){
		positiveChance = .011
		negativeChance = .9;
	}else if(this.quality===1){
		positiveChance = .033
		negativeChance = .3;
	}else if(this.quality===2){
		positiveChance = .1
		negativeChance = .1;
	}else if(this.quality===3){
		positiveChance = .3
		negativeChance = .033;
	}else if(this.quality===4){
		positiveChance = .9
		negativeChance = .011;
	}
	
	
	//plus cold
	r1=Math.random();
	r2=Math.random();
	if(r1 < positiveChance){
		this.coldResistance = 1-((1-this.coldResistance)*(1-r2*.5));
		this.coldBonus++;
	}
	
	//plus water
	r1=Math.random();
	r2=Math.random();
	if(r1 < positiveChance){
		this.waterResistance = 1-((1-this.waterResistance)*(1-r2*.5));
		this.waterBonus++;
	}
	
	//plus wind
	r1=Math.random();
	r2=Math.random();
	if(r1 < positiveChance){
		this.windResistance = 1-((1-this.windResistance)*(1-r2*.5));
		this.windBonus++;
	}
	
	//plus weight
	r1=Math.random();
	r2=Math.random();
	if(r1 < positiveChance){
		this.weight *= 1-(r2 *.5);
		this.weightBonus++;
	}
	
	//plus stack
	r1=Math.random();
	if(r1 < positiveChance){
		if(!this.canStack){
			this.canStack = true;
			this.stackBonus++;
		}
	}
	
	
	
	
	//minus cold
	r1=Math.random();
	r2=Math.random();
	if(r1 < negativeChance){
		this.coldResistance *= 1-(r2*.3);
		this.coldBonus--;
	}
	
	//minus water
	r1=Math.random();
	r2=Math.random();
	if(r1 < negativeChance){
		this.waterResistance *= 1-(r2*.3);
		this.waterBonus--;
	}
	
	//minus wind
	r1=Math.random();
	r2=Math.random();
	if(r1 < negativeChance){
		this.windResistance *= 1-(r2*.3);
		this.windBonus--;
	}
	
	//minus weight
	r1=Math.random();
	r2=Math.random();
	if(r1 < negativeChance){
		this.weight *= 1 + (r2*.5);
		this.weightBonus--;
	}
	
	//minus stack
	r1=Math.random();
	if(r1 < negativeChance){
		if(this.canStack){
			this.canStack = false;
			this.stackBonus--;
		}
	}
	
	//minus last leg
	r1=Math.random();
	if(r1 < negativeChance){
		this.lastLeg = true;
	}
	
	
	
	
	/*
	//positive attributes:
		+50% cold resist
		+50% water resist
		+50% wind resist
		-50% weight
	loose fitting (can stack)
	
	negative attributes
		-30% cold resist
		-30% water resist
		-30% wind resist
		+30% weight
		last leg (if you unequip, item is destroyed)
		tight fitting (can’t stack)
	*/
}
		
		
function Hat(qualityBonus){
	this.qualityBonus = qualityBonus;

	Clothing.call(this);
	
	this.ssX = 48;
	this.ssY = 16;
	
	this.equipX=16;
	this.equipY=16;
	
	
	
	this.equipType = "hat";
	
	if(Math.random()>.5){
		this.coldResistance = .5;
		this.waterResistance = .1;
		this.windResistance = .5;
		this.weight = 1;
		this.clothingType = "ushanka";
	}else{
		this.coldResistance = .3;
		this.waterResistance = .2;
		this.windResistance = .3;
		this.weight = .5;
		this.clothingType = "balaclava";
		this.canStack = "true";
	}
	this.description = "";
	
	this.mutate();
}
Hat.prototype = new Clothing();
Hat.prototype.constructor = Hat;


function Jacket(qualityBonus){
	this.qualityBonus = qualityBonus;

	Clothing.call(this);
	
	this.equipType = "jacket";
	this.ssX =64;
	this.ssY =16;
	
	this.equipX=32;
	this.equipY=16;
	
	if(Math.random()>.5){
		this.coldResistance = .55;
		this.waterResistance = .4;
		this.windResistance = .5;
		this.weight = 2.5;
		this.clothingType = "parka";
	}else{
		this.coldResistance = .35;
		this.waterResistance = .05;
		this.windResistance = .1;
		this.weight = .7;
		this.clothingType = "shirt";
		this.canStack = "true";
	}
	
	this.mutate();
}
Jacket.prototype = new Clothing();
Jacket.prototype.constructor = Jacket;


function Pants(qualityBonus){
	this.qualityBonus = qualityBonus;

	Clothing.call(this);
	
	this.equipType = "pants";
	this.ssX = 48;
	this.ssY = 24;
	
	this.equipX=32;
	this.equipY=32;
	
	if(Math.random()>.5){
		this.coldResistance = .5;
		this.waterResistance = .4;
		this.windResistance = .4;
		this.weight = 2;
		this.clothingType = "trousers";
	}else{
		this.coldResistance = .35;
		this.waterResistance = .05;
		this.windResistance = .1;
		this.weight = 1;
		this.clothingType = "leggings";
		this.canStack = "true";
	}
	
	this.mutate();
}
Pants.prototype = new Clothing();
Pants.prototype.constructor = Pants;


function Glove(qualityBonus){
	this.qualityBonus = qualityBonus;

	Clothing.call(this);
	
	if(Math.random()>.5){
		this.side = "left"
	}else{
		this.side = "right";
	}
	
	//LEFT/RIGHT
	if(this.side == "left"){
		this.equipType = "left glove";
		this.ssX = 64;
		this.ssY = 24;	
		this.equipX= 0;
		this.equipY=32;
	}else{
		this.equipType = "right glove";
		this.ssX = 96;
		this.ssY = 16;	
		this.equipX=16;
		this.equipY=32;
	}
	
	if(Math.random()>.5){
		this.coldResistance = .5;
		this.waterResistance = .4;
		this.windResistance = .4;
		this.weight = .4;
		this.clothingType = "mitten";
	}else{
		this.coldResistance = .3;
		this.waterResistance = .4;
		this.windResistance = .3;
		this.weight = .4;
		this.clothingType = "glove";
		this.canStack = "true";
	}
	
	this.mutate();
}
Glove.prototype = new Clothing();
Glove.prototype.constructor = Glove;


function Boot(qualityBonus){
	this.qualityBonus = qualityBonus;

	Clothing.call(this);
	
	if(Math.random()>.5){
		this.side = "left"
	}else{
		this.side = "right";
	}
	
	//LEFT/RIGHT
	if(this.side == "left"){
		this.equipType = "left boot";
		this.ssX =80;
		this.ssY = 16;	
		this.equipX=48;
		this.equipY=32;
	}else{
		this.equipType = "right boot";
		this.ssX = 80;
		this.ssY =24;	
		this.equipX=64;
		this.equipY=32;
	}
	
	if(Math.random()>.5){
		this.coldResistance = .3;
		this.waterResistance = .55;
		this.windResistance = .5;
		this.clothingType = "boot";
		this.weight = 3;
	}else{
		this.coldResistance = .4;
		this.waterResistance = .05;
		this.windResistance = .1;
		this.weight = .2;
		this.clothingType = "sock";
		this.canStack = "true";
	}
	
	this.mutate();
}
Boot.prototype = new Clothing();
Boot.prototype.constructor = Boot;









//FOOD HERE
function Food(){
	Item.call(this);
	
	this.poison = 0;
}
Food.prototype = new Item();
Food.prototype.constructor = Food;
		
Food.prototype.use = function(){

	if(Math.random()<this.poison){
		if(Math.random()>.9){
			player.die("poison");
		}else{
			rconsole.log("Ugh, that tastes bitter.");
			
			//todo: add more statuses
			var r = Math.random();
			if(r<.5){
				player.hunger -= this.hungerRefill*1.2;
			}else{
				player.coreTemp -= 1;
			}
		}
	}

	player.foodEaten++;

	player.hunger = Math.min(player.startingHunger,player.hunger+this.hungerRefill);
	
	return true;
}

Food.prototype.getName=function(){
	if(this.hallucinate<player.hallucinate){
		return "???";
	}
	
	return this.foodType;
}


function Mushroom(){
	Food.call(this);
	
	this.poison = 0;
	this.foodType = "mushroom";
	
	this.hungerRefill = 30;
	
	var r = Math.random();
	if(r<.33){
		this.ssX = 112;
		this.ssY = 16;
		this.poison = .15;
	}else if(r<.66){
		this.ssX = 96;
		this.ssY = 24;
		this.poison = .1;
	}else{
		this.ssX = 112;
		this.ssY = 24;
		this.poison = .9;
	}
	this.weight = .1;
}
Mushroom.prototype = new Food();
Mushroom.prototype.constructor = Mushroom;


function Bread(){
	Food.call(this);
	
	this.foodType = "bread";
	
	this.hungerRefill = 40;
	this.ssX = 96;
	this.ssY = 64;
	this.weight = 2;
	
	this.description = "A moderately fresh loaf of bread. A bit smashed, but otherwise edible.";
}
Bread.prototype = new Food();
Bread.prototype.constructor = Bread;


function Berry(){
	Food.call(this);
	
	this.foodType = "carrion flower berry";
	
	this.hungerRefill = 15;
	this.ssX = 80;
	this.ssY = 32;
	this.weight = .1;
	
	this.description = "Smells like rotting meat. Not to be confused with the Rafflesia genus.";
}
Berry.prototype = new Food();
Berry.prototype.constructor = Berry;




function SleepingBag(){
	Item.call(this);
	
	this.ssX = 96;
	this.ssY = 32;
	
	this.name = "sleeping bag";
	
	this.weight = 10;
}
SleepingBag.prototype = new Item();
SleepingBag.prototype.constructor=SleepingBag;
SleepingBag.prototype.use=function(){
	if(this.wetness>0){
		rconsole.log("You can't sleep in that while it's wet.");
		return false;
	}
	player.sleep(.6,.2);
	
	return false;
}

function Tent(){
	Item.call(this);
	
	this.ssX = 112;
	this.ssY = 32;
	
	this.name = "tent";
	
	this.weight = 20;
}
Tent.prototype = new Item();
Tent.prototype.constructor=Tent;

Tent.prototype.use=function(){
	if(this.wetness>0){
		rconsole.log("You can't sleep in that while it's wet.");
		return false;
	}
	player.sleep(.4,.5);
	
	return false;
}



function Parachute(){
	Item.call(this);
	
	this.ssX = 64;
	this.ssY = 64;
	
	this.name = "parachute";
	this.description = "A recently opened parachute. Could be used as a makeshift sleeping bag.";
	
	this.weight = 35;
}
Parachute.prototype = new Item();
Parachute.prototype.constructor=Parachute;

Parachute.prototype.use=function(){
	if(this.wetness>0){
		rconsole.log("You can't sleep in that while it's wet.");
		return false;
	}
	player.sleep(.3,.3);
	
	return false;
}


function Blanket(){
	Item.call(this);
	
	this.ssX = 96;
	this.ssY = 40;
	
	this.name = "blanket";
	
	this.weight = 5;
}
Blanket.prototype = new Item();
Blanket.prototype.constructor=Blanket;

Blanket.prototype.use=function(){
	if(this.wetness>0){
		rconsole.log("You can't sleep in that while it's wet.");
		return false;
	}
	player.sleep(.5,.1);
	
	return false;
}



function Key(){
	Item.call(this);
	
	this.ssX = 112;
	this.ssY = 40;
	
	this.equipType = "key";
	
	this.name = "key";
	
	this.weight = .1;
}
Key.prototype = new Item();
Key.prototype.constructor=Key;


Key.prototype.use=function(){
	rconsole.log("Use that on a door or chest.");
	
	return false;
}



function Compass(){
	Item.call(this);
	
	this.ssX = 80;
	this.ssY = 40;
	
	this.weight = .3;
	
	this.name = "compass";
}
Compass.prototype = new Item();
Compass.prototype.constructor=Compass;


Compass.prototype.use=function(){
	rconsole.log("The compass operates quite nicely without your intervention.");
	
	return false;
}


function Watch(){
	Item.call(this);
	
	this.ssX = 80;
	this.ssY = 48;
	
	this.weight = .3;
	
	this.name = "watch";
	this.description = "a glow in the dark watch.";
}
Watch.prototype = new Item();
Watch.prototype.constructor=Watch;

Watch.prototype.use=function(){
	rconsole.log("The watch operates quite nicely without your intervention.");
	
	return false;
}


function Shotgun(){
	Item.call(this);
	
	this.ssX = 96;
	this.ssY = 48;
	
	this.weight = 10;
	
	this.ammo = 0;
	
	this.name = "shotgun";
	this.description = "";
}
Shotgun.prototype = new Item();
Shotgun.prototype.constructor=Shotgun;

Shotgun.prototype.use=function(){
	if(this.ammo===0){
		rconsole.log("You'll have to load that first.");
	}else{
		var foundRabbit = null;	
					
		for(var k=0;k<map.rabbits.length;k++){
			var rabbit = map.rabbits[k];
		
			if(player.direction == 0){
				if(rabbit.x===player.x && rabbit.y<player.y && rabbit.y>player.y-20){
					foundRabbit = rabbit;
					break;
				}
			}else if(player.direction == 1){
				if(rabbit.y===player.y && rabbit.x>player.x && rabbit.x<player.x+20){
					foundRabbit = rabbit;
					break;
				}
			}else if(player.direction == 2){
				if(rabbit.x===player.x && rabbit.y>player.y && rabbit.y<player.y+20){
					foundRabbit = rabbit;
					break;
				}
			}else{
				
				if(rabbit.y===player.y && rabbit.x<player.x && rabbit.x>player.x-20){
					foundRabbit = rabbit;
					break;
				}
			}
		}
		
		if(foundRabbit !== null){
			var distance = Math.abs((foundRabbit.x-player.x)+(foundRabbit.y-player.y));
			var hit = false;
			if(Math.random()>((distance-5)/15)){
				hit = true;
			}
			
			if(hit){
				rconsole.log("You hit.");
				
				var hide = new Hide();
				var meat = new Meat();
	
				var rabbitTile = map.getTile(foundRabbit.x,foundRabbit.y);
				rabbitTile.pushItem(hide);
				rabbitTile.pushItem(meat);
				foundRabbit.x = -1000;
				foundRabbit.y = -1000;
			}else{
				rconsole.log("You missed.");
			}
			
			this.ammo=0;
			game.updateTime(.5, .5);
		}else{
			rconsole.log("Nothing to fire at in your line of sight.");
		}
	}
	
	return false;
}

Shotgun.prototype.getExtraDetails=function(){
	return '<div>loaded with '+this.ammo+' shells</div>';
}


function Ammo(){
	Item.call(this);
	
	this.ssX = 112;
	this.ssY = 48;
	
	this.weight = .1;
	
	this.name = "birdshot";
	this.description = "used for hunting small game";
}
Ammo.prototype = new Item();
Ammo.prototype.constructor=Ammo;

Ammo.prototype.use=function(){
	var items = inventory.items;
	for(var i=0;i<items.length;i++){
		if(items[i]!== null && items[i].name === "shotgun"){
			if(items[i].ammo===0){
				items[i].ammo++;
				
				rconsole.log("You loaded your shotgun.");
				return true;
			}
		}
	}
	
	rconsole.log("You need an unloaded shotgun to put that in.");
	
	return false;
}


function Meat(){
	Item.call(this);
	
	this.ssX = 96;
	this.ssY = 56;
	
	this.hungerRefill = 50;
	
	this.weight = 4;
	
	this.name = "rabbit meat";
	this.foodType = "rabbit meat";
	this.description = "delicious meat; just watch out for 'rabbit starvation'";
}
Meat.prototype = new Food();
Meat.prototype.constructor=Meat;

function Hide(){
	Item.call(this);
	
	this.ssX = 112;
	this.ssY = 56;
	
	this.weight = 3;
	
	this.name = "rabbit hide";
	this.description = "could be turned into some nice clothes";
}
Hide.prototype = new Item();
Hide.prototype.constructor=Hide;

Hide.prototype.use=function(){
	//create new item
	
	var crafted;
	if(Math.random()<.333){
		crafted = new Boot(4);
	}else if(Math.random()<.666){
		crafted = new Glove(4);
	}else{
		crafted = new Hat(4);
	}
	
	rconsole.log("You craft the hide into an "+crafted.getName()+".");
	
	if(!inventory.pickUp(crafted)){
		player.getTile().pushItem(crafted);
	}
	
	return true;
}




function Transponder(){
	Item.call(this);
	
	this.ssX = 80;
	this.ssY = 72;
	
	this.weight = 7;
	
	this.name = "transponder";
	this.description = "Some sort of device used to manage inventory.";
}
Transponder.prototype = new Item();
Transponder.prototype.constructor=Transponder;

Transponder.prototype.getExtraDetails=function(){
	var details = "";
	
	var distance = Math.floor(Math.pow(Math.pow(player.x-this.cacheX,2)+Math.pow(player.y-this.cacheY,2),.5));
	
	details += '<div>Distance: '+distance+'</div>';
	
	details += this.itemsDescription;
	
	return details;
}

Transponder.prototype.use=function(){
	
	rconsole.log("That doesn't seem to do much else.");
	
	return false;
}




function Flashlight(){
	Item.call(this);
	
	this.ssX = 80;
	this.ssY = 64;
	
	this.weight = 1.5;
	
	this.name = "flashlight";
}
Flashlight.prototype = new Item();
Flashlight.prototype.constructor=Flashlight;
Flashlight.prototype.use = function(){
	this.equipped = !this.equipped;
}


function Binoculars(){
	Item.call(this);
	
	this.ssX = 96;
	this.ssY = 72;
	
	this.weight = 1.5;
	
	this.name = "binoculars";
}
Binoculars.prototype = new Item();
Binoculars.prototype.constructor=Binoculars;
Binoculars.prototype.use = function(){
	this.equipped = !this.equipped;
}