

$(function(){

	var img = new Image();
	img.onload = setLoad;
	
	var uiButtons = [];
	uiButtons[0] = {
		label: "(P)ICK UP",
		handler: function(){
			inventory.pickUpNext();
		}
	}
	uiButtons[1] = {
		label: "DR(O)P",
		handler: function(){
			inventory.drop();
		}
	}
	uiButtons[2] = {
		label: "S(L)EEP",
		handler: function(){
			player.sleep(0,0);
		}
	}
	uiButtons[3] = {
		label: "D(I)SROBE",
		handler: function(){
			player.disrobe();
		}
	}
	uiButtons[4] = {
		label: "WAI(T)",
		handler: function(){
			player.wait();
		}
	}
	
	var ctx = document.getElementById("canvas").getContext("2d");
	ctx.webkitImageSmoothingEnabled = false;
	ctx.mozImageSmoothingEnabled = false;
	
	var bufferCanvas =document.getElementById("bufferCanvas");
	var bufferCtx = bufferCanvas.getContext("2d");
	
	bufferCtx.webkitImageSmoothingEnabled = false;
	bufferCtx.mozImageSmoothingEnabled = false;
	
	showTitle();
	
	img.src = "img/ss.png";
	
	function setLoad(){
		game.imageLoaded = true;
		
		drawTitle();
	}
	
	function startGame(){
		game.showTitle = false;
		$(".rpanel").show();
		
		$("#title").hide();
	
		game.init();
		map.init();
		player.init();
		map.generate();
		inventory.init();
		temp.init();
		
		rconsole.clear();
		rdetail.clear();
		
		rconsole.logNoBreak('<div class="help">Press \'h\' for HELP.</div>');
		rconsole.logNoBreak('<div class="plot">The last thing he said was "If you want to live, head '+game.directions[game.roadDirection]+'."</div>');
		
		
		drawEverything();
		
		game.animateInterval=setInterval(function(){
			game.counter++;
			ctx.clearRect (0,0,576,352);
			map.draw(ctx, img,bufferCanvas,bufferCtx);
		},500);
	}
	
	function tick(){
		//clear canvas
		
		drawEverything();
	}
	
	function showTitle(){
		$("#title").show();
		$("#title").backstretch("img/winter-landscape.jpg");
	
		$("#whiteout").show();
		$("#whiteout").fadeOut({
			duration:2000
		});
	
		clearInterval(game.animateInterval);
	
		game.mapLoaded = false;
		game.anyKeyReady = false;
		setTimeout(function(){
			game.anyKeyReady = true;
		},300);
		game.showTitle = true;
	
		drawTitle();
	}
	
	function drawTitle(){
		$(".rpanel").hide();
		
		if(!game.imageLoaded){
			var smallMessage = "loading";
		}else{
			var smallMessage = "press any key to continue";
		}
		
		$("#title h2").html(smallMessage);
		
		/*ctx.clearRect(0,0,960,512);
		
		ctx.font= "50px Helvetica, Arial";
	
		ctx.fillStyle = "rgba(255,255,255,1)";
		ctx.fillText("A False Saint, An Honest Rogue", 130,340);
		
		ctx.font = "20px Helvetica, Arial";
		
		ctx.fillText(smallMessage, 230,400);
		*/
	}
	
	function drawEverything(){
		game.counter++;
	
		ctx.clearRect (0,0,960,512);
		
		map.draw(ctx, img,bufferCanvas,bufferCtx);
		
		//separate out to item actions only?
		inventory.draw(ctx, img);
		
		drawUI(ctx);
		
		temp.draw(ctx);
		
		player.drawPlayerSummary(ctx);
	}
	
	
	
	
	function drawUI(ctx){
		ctx.font= "12px Verdana";
		
		var x,y;
		
		var buttonMargin = 6;
		
		for(var i=0;i<uiButtons.length;i++){
			x = (i%4)*80+624;
			y = Math.floor(i/4)*32+128;
			
			ctx.fillStyle = "rgba(150,150,150,1)";
			ctx.fillRect (x+buttonMargin,y+buttonMargin,80-buttonMargin,32-buttonMargin);			
			ctx.fillStyle = "rgba(0,0,0,1)";
			ctx.fillText(uiButtons[i].label, x+buttonMargin+5, y+22);
		}
		
	}
	
	$(window).keydown(function(e){
		if(!game.showTitle && game.mapLoaded){
			if(!game.isDead){
				if(e.which == 87 || e.which == 38){ 
					player.moveForward();
				}
				
				if(e.which == 83 || e.which == 40){ 
					player.moveBack();
				}
				
				if(e.which == 65 || e.which == 37){ 
					player.turnLeft();
				}
				
				if(e.which == 68 || e.which == 39){ 
					player.turnRight();
				}
				
				if(e.which == 80){
					//PICK UP
					uiButtons[0].handler();
				}
				
				if(e.which == 79){
					//DROP
					uiButtons[1].handler();
				}
				
				if(e.which == 76){
					//SLEEP
					uiButtons[2].handler();
				}
				
				if(e.which == 73){
					//DISROBE
					uiButtons[3].handler();
				}
				
				if(e.which == 72){
					game.help();
				}
				
				if(e.which == 190 || e.which === 84){
					player.wait();
				}
				
				tick();
			}else{
				if(e.which===89){
					showTitle();
				}
			}
		}else{
			if(game.imageLoaded){
				startGame();
			}
		}
	});
	
	$("#canvas").click(function(e){
		var x = e.clientX-$("#canvas").offset().left;
		var y = e.clientY-$("#canvas").offset().top;
	
		if(!game.showTitle && !game.isDead && game.mapLoaded){
			//show name, description, DROP, and (un)equip
	
			//FIRST get item index
			inventory.click(x,y);
			
			//handle buttons
			if(x >= 624
			&& x <= 624+320
			&& y >= 128
			&& y <= 128+64){
				var buttonIndex = Math.floor((y-128)/32)*4;
				buttonIndex+=Math.floor((x-624)/80);
				
				if(buttonIndex>=0 && buttonIndex < uiButtons.length){
					uiButtons[buttonIndex].handler();
				}
				
			}
			
			drawEverything();
		}
	});
});