temp = {
	startingTemp: 50,
	tempSwing: 20,
	temp: null,
	init:function(){
		temp.update();
		
		temp.windMag = 10;
		temp.wind = 0;
		
		temp.selectNewWind();
		temp.updateWind();
	},
	draw: function(ctx){
		var tempDrawText = temp.formatTemp(temp.temp)+" | "+Math.floor(temp.wind)+"mph";

		if(player.hasCompass()){
			if(player.getShadow()<.5){
				tempDrawText +=  " | "+ game.directions[player.direction].substring(0,1);
			}else{
				tempDrawText +=  " | ?";
			}
		}
		if(player.hasWatch()){
			var hour = game.getHour();
			var formattedHour = Math.floor((hour)%12);
			if(formattedHour===0){
				formattedHour="12";
			}
			var formattedMinute = +Math.floor((hour%1)*60);
			if(formattedMinute<10){
				formattedMinute="0"+formattedMinute;
			}
			
			var formattedTime = formattedHour+":"+formattedMinute;
			
			if(hour>=12){
				formattedTime+="pm";
			}else{
				formattedTime+="am";
			}
			tempDrawText +=  " | "+ formattedTime;
		}
	
		ctx.font= "20px Verdana";
		ctx.fillStyle = "rgba(255,255,255,1)";
		ctx.fillText(tempDrawText, 624,355);
	},
	update:function(){
		temp.temp=
			temp.startingTemp
			-(game.time/game.timePerDay)*4
			+temp.tempSwing*(Math.cos(2*Math.PI*game.time/(game.timePerDay))-1);
			
		temp.updateWind();
	},
	updateWind: function(){
		temp.wind = temp.windMag *(.666+.333*Math.cos(Math.PI+(2*Math.PI * game.time*(13/7)/(game.timePerDay))))
		if(Math.random()<.01){
			temp.selectNewWind();
		}
		
	},
	formatTemp:function(temp){
		return Math.ceil(temp) + "\u00B0"+"F";
	},
	selectNewWind:function(){
		temp.windDirection = Math.floor(Math.random()*4)%4;
		temp.windMag = Math.min(100,Math.max(0,temp.windMag+Math.random()*15-5));
	}
}